from crysfipy.reion import re, cfpars, neutronint
import crysfipy.const as C
from crysfipy.cfmatrix import *
import random
import sys


lim = 1.1

def getB():
    b20 = random.uniform(-lim,lim)
    #b40 = random.uniform(-lim,lim)
    #b44 = random.uniform(-lim,lim)
    b40 = random.uniform(-0.08,0.08)
    b44 = random.uniform(-0.5,0.5)
    return [b20,b40,b44]


def runMP(amount, out_q):
    res = []
    e1 = 4.8846   # FROM FILE CeAuAl3 figures.ipynb
    e2 = 24.163    # FROM FILE CeAuAl3 figures.ipynb
    delta = 0.02  

    x = 0
    y = 0
    while y < amount:
        bs = getB()
        try:
            ce = re("Ce", [0,0,0], cfpars("t", bs[0], bs[1], bs[2]))
            ce.getlevels()
            e = ce.energy
            y += 1
            if abs(e[2] - e1) < delta * e1 and abs(e[4] - e2) < delta * e2:
                print(e[2], e[4], y, bs)
                x+=1
                res.append(bs)
                sys.stdout.flush()
        except e:
            print("error", e)
    out_q.put(res)